package org.appconn.mgmt;

import org.appconn.channel.*;

import java.net.SocketAddress;

/**
 * Class generated by <i>appconn</i> Coders.
 * Coders version: 1.2
 */
public class AppClientServiceClient implements AppClientService {

    private final SocketAddress remote;

    public AppClientServiceClient(SocketAddress remote) {
        this.remote = remote;
    }

    private static final TypeReader<org.appconn.mgmt.Address> ORG_APPCONN_MGMT_ADDRESS_READER = readBuffer -> TypeReader.getType(readBuffer, r -> new org.appconn.mgmt.Address(TypeReader.STRING_READER.get(r), r.getInt()));

    private static final TypeWriter<org.appconn.mgmt.Address> ORG_APPCONN_MGMT_ADDRESS_WRITER = (writeBuffer, type) -> TypeWriter.putType(writeBuffer, type, (w, t) -> {
        TypeWriter.STRING_WRITER.put(w, t.getHost());
        w.putInt(t.getPort());
    });

    private static final TypeReader<org.appconn.mgmt.Server> ORG_APPCONN_MGMT_SERVER_READER = readBuffer -> TypeReader.getType(readBuffer, r -> new org.appconn.mgmt.Server(r.getInt(), r.getInt(), TypeReader.STRING_READER.get(r), ORG_APPCONN_MGMT_ADDRESS_READER.get(r), r.get()));

    private static final TypeWriter<org.appconn.mgmt.Server> ORG_APPCONN_MGMT_SERVER_WRITER = (writeBuffer, type) -> TypeWriter.putType(writeBuffer, type, (w, t) -> {
        w.putInt(t.getId());
        w.putInt(t.getMappingKey());
        TypeWriter.STRING_WRITER.put(w, t.getName());
        ORG_APPCONN_MGMT_ADDRESS_WRITER.put(w, t.getAddress());
        w.put(t.getState());
    });

    @Override
    public void setServers(java.lang.String arg0, java.util.Collection<org.appconn.mgmt.Server> arg1) {
        try (AbstractClient client = AbstractClient.newSingletonReturnTcpClient(remote, 4000)) {
            FutureReturn<Void> ret = AbstractClient.futureReturn(TypeReader.VOID_READER, 32000000000L);
            Writer.putCall(client.getWriteBuffer(), 8432, client.add(ret), ret, w -> {
                TypeWriter.STRING_WRITER.put(w, arg0);
                TypeWriter.putCollection(w, arg1, ORG_APPCONN_MGMT_SERVER_WRITER);
            });
            ret.getReturn();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

}
